unit SetBrush;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, ColorGrd, StdCtrls;

type
  TBrushDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    GroupBox2: TGroupBox;
    ColorGrid: TColorGrid;
    AdvancedColorBtn: TButton;
    GroupBox3: TGroupBox;
    bsBDiagonalBtn: TSpeedButton;
    bsSolidBtn: TSpeedButton;
    bsClearBtn: TSpeedButton;
    bsVerticalBtn: TSpeedButton;
    bsCrossBtn: TSpeedButton;
    bsFDiagonalBtn: TSpeedButton;
    bsDiagCrossBtn: TSpeedButton;
    bsHorizontalBtn: TSpeedButton;
    ColorDlg: TColorDialog;
    ColorPanel: TPanel;
    procedure AdvancedColorBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure BSBtnClick(Sender: TObject);
    procedure ColorGridChange(Sender: TObject);
    procedure ColorPanelClick(Sender: TObject);
  private
    FbsStyle : TBrushStyle;
  public
    procedure DeterminColorGrid;
  end;

var
  BBrush : TBrush;
  procedure SetBrushDlg( var ABrush : TBrush );

implementation

{$R *.DFM}

procedure SetBrushDlg( var ABrush : TBrush ) ;
var
   BrushDlg : TBrushDlg;
begin
     BBrush := TBrush.Create;
     BBrush.Assign(ABrush);
     BrushDlg := TBrushDlg.Create(Application);
     if BrushDlg.ShowModal = mrOK then ABrush.Assign(BBrush);
     BrushDlg.Free;
     BBrush.Free;
end;

procedure TBrushDlg.DeterminColorGrid;
begin
     case BBrush.Color of
          clBlack  : ColorGrid.ForegroundIndex := 0;
          clMaroon : ColorGrid.ForegroundIndex := 1;
          clGreen  : ColorGrid.ForegroundIndex := 2;
          clOlive  : ColorGrid.ForegroundIndex := 3;
          clNavy   : ColorGrid.ForegroundIndex := 4;
          clPurple : ColorGrid.ForegroundIndex := 5;
          clTeal   : ColorGrid.ForegroundIndex := 6;
          clSilver : ColorGrid.ForegroundIndex := 7;
          clGray   : ColorGrid.ForegroundIndex := 8;
          clRed    : ColorGrid.ForegroundIndex := 9;
          clLime   : ColorGrid.ForegroundIndex := 10;
          clYellow : ColorGrid.ForegroundIndex := 11;
          clBlue   : ColorGrid.ForegroundIndex := 12;
          clFuchsia : ColorGrid.ForegroundIndex := 13;
          clAqua   : ColorGrid.ForegroundIndex := 14;
          clWhite  : ColorGrid.ForegroundIndex := 15;
          else
          begin
              ColorGrid.ForegroundIndex := -1;
              ColorPanel.Color := BBrush.Color;
              ColorPanel.Caption := 'FG';
          end;
     end;
end;

procedure TBrushDlg.AdvancedColorBtnClick(Sender: TObject);
//  ư  
var
   AColor : TColor;
begin
     if ColorGrid.ForegroundIndex = -1 then
        ColorDlg.Color := ColorPanel.Color
     else
     begin
          case ColorGrid.ForegroundIndex of
               0 : ColorDlg.Color := clBlack;
               1 : ColorDlg.Color := clMaroon;
               2 : ColorDlg.Color := clGreen;
               3 : ColorDlg.Color := clOlive;
               4 : ColorDlg.Color := clNavy;
               5 : ColorDlg.Color := clPurple;
               6 : ColorDlg.Color := clTeal;
               7 : ColorDlg.Color := clSilver;
               8 : ColorDlg.Color := clGray;
               9 : ColorDlg.Color := clRed;
              10 : ColorDlg.Color := clLime;
              11 : ColorDlg.Color := clYellow;
              12 : ColorDlg.Color := clBlue;
              13 : ColorDlg.Color := clFuchsia;
              14 : ColorDlg.Color := clAqua;
              15 : ColorDlg.Color := clWhite;
          end;
     end;

     if ColorDlg.Execute then
     begin
          BBrush.Color := ColorDlg.Color;
          DeterminColorGrid;
     end;
end;

procedure TBrushDlg.FormCreate(Sender: TObject);
begin
     DeterminColorGrid;
     case BBrush.Style of
          bsSolid : bsSolidBtn.Down := True;
          bsClear : bsClearBtn.Down := True;
          bsHorizontal: bsHorizontalBtn.Down := True;
          bsVertical  : bsVerticalBtn.Down := True;
          bsFDiagonal : bsFDiagonalBtn.Down := True;
          bsBDiagonal : bsBDiagonalBtn.Down := True;
          bsCross     : bsCrossBtn.Down := True;
          bsDiagCross : bsDiagCrossBtn.Down := True;
     end;
     FbsStyle := BBrush.Style;
end;

procedure TBrushDlg.OKBtnClick(Sender: TObject);
begin
     with BBrush do
     begin
          if ColorGrid.ForegroundIndex = -1 then
             Color := ColorPanel.Color
          else
          begin
               case ColorGrid.ForegroundIndex of
                    0 : Color := clBlack;
                    1 : Color := clMaroon;
                    2 : Color := clGreen;
                    3 : Color := clOlive;
                    4 : Color := clNavy;
                    5 : Color := clPurple;
                    6 : Color := clTeal;
                    7 : Color := clSilver;
                    8 : Color := clGray;
                    9 : Color := clRed;
                    10 : Color := clLime;
                    11 : Color := clYellow;
                    12 : Color := clBlue;
                    13 : Color := clFuchsia;
                    14 : Color := clAqua;
                    15 : Color := clWhite;
               end;
          end;
          Style := FbsStyle;
     end;

end;

procedure TBrushDlg.BSBtnClick(Sender: TObject);
begin
     FbsStyle := TBrushStyle( TComponent(Sender).Tag );
end;

procedure TBrushDlg.ColorGridChange(Sender: TObject);
begin
     ColorPanel.Caption := '';
end;

procedure TBrushDlg.ColorPanelClick(Sender: TObject);
begin
     ColorGrid.ForegroundIndex := -1;
     ColorPanel.Caption := 'FG';
end;

end.
